' {$STAMP BS2p}
' {$PBASIC 2.5}
' {$PORT COM9}
'voltmeter_3.bas
'simulates a analog voltmeter
'Albert Catano
'September 19,2004

'Color table
  Green CON %00111000
  Red CON %00000111
  White CON %11111111
  Yellow CON %00111111
  Blue CON %11000000
  Black CON %00000000

'Drawing commands
  Arc CON $2F
  Box CON $42
  Box_fill CON $43
  Circle_r CON $29
  Circle_r_fill CON $39
  Ezcls CON $21
  H_line CON $40
  Light_off CON $23
  Light_on CON $22
  Line_to_xy CON $28
  Picture CON $2A
  Plot CON $26
  Plot_xy CON $27
  Print_char CON $2C
  Print_char_bg CON $3C
  Print_string CON $2D
  Text_north CON $60                                     '- default (landscape)
  Text_east CON $61                                      '- portrait
  Text_south CON $62                                     '- landscape upside down
  Text_west CON $63                                        '- portrait upside down
  Print_string_bg CON $3D
  Put_bitmap CON $2E
  Select_font CON $2B
  Set_bg_color CON $34
  Set_color CON $24
  Set_xy CON $25
  V_line CON $41
  Picture_rom CON $50
  Put_icon CON $57

'Variables
 N VAR Byte
 Xs VAR Byte
 Ys VAR Byte
 Xe VAR Byte
 Ye VAR Byte
 Color VAR Byte
 degr  VAR     Word
 sine  VAR     Word
 cosine  VAR     Word
 cnt VAR Byte

'Initialize display
SEROUT 0,240,[Light_on,Set_color,White,Ezcls,Set_color,Black]
SEROUT 0,240,[set_xy,70,5,print_string,"BS2P on the ezLCD",0]
cnt=0
Main:
SEROUT 0,240,[Set_xy,120,80,arc,60,150,363]
SEROUT 0,240,[Set_xy,120,80,arc,63,150,363]
SEROUT 0,240,[Set_xy,120,80,arc,20,150,360]
SEROUT 0,240,[Set_xy,120,80,arc,22,150,360]
SEROUT 0,240,[Set_xy,88,135,line_to_xy,110,98]
SEROUT 0,240,[Set_xy,150,135,line_to_xy,130,97]
SEROUT 0,240,[set_xy,105,140,box,135,120]
SEROUT 0,240,[set_xy,106,139,box,134,121]
SEROUT 0,240,[select_font,2]
da:
FOR degr = 50 TO 310 STEP 10                   ' Use degrees
    sine = (SIN (degr * 128 / 180)+127)*80/255              ' Convert to brads, do SIN
    cosine=(COS (degr * 128 / 180)+127)*80/255
SEROUT 0,240,[Set_color,white]
SEROUT 0,240,[Set_xy,80+sine,40+cosine,circle_r_fill,10]
PAUSE 50
NEXT
FOR degr = 310 TO 50 STEP 10                   ' Use degrees
    sine = (SIN (degr * 128 / 180)+127)*80/255              ' Convert to brads, do SIN
    cosine=(COS (degr * 128 / 180)+127)*80/255
SEROUT 0,240,[Set_xy,80+sine,40+cosine,circle_r_fill,10]
IF degr <80 THEN SEROUT 0,240,[set_color,red] ELSE SEROUT 0,240,[set_color,green]
SEROUT 0,240,[set_xy,110,125,print_string,DEC cnt,0]
SEROUT 0,240,[Set_xy,80+sine,40+cosine,circle_r_fill,10]
PAUSE 100
SEROUT 0,240,[set_xy,110,125,set_color,white,print_string,DEC cnt,0]
cnt=cnt+4
NEXT
SEROUT 0,240,[set_color,black]
cnt=0
GOTO da
END
